
	%--------------------------------------------------------------------------------------------------------%	
	%--------------------------------------------------------------------------------------------------------%
	% Function empcdf
	% 	last modification 24/9/05
	%DESCRIPTION : 
	%	Calculate the empirical cdf
	%--------------------------------------------------------------------------------------------------------%
	%--------------------------------------------------------------------------------------------------------%

function [x, p] = empcdf(x)

	nargsin = nargin;
	error(nargchk(1,2, nargsin) );

	sx = size(x);
	dx = ndims(x);
	if( nargsin < 2 )
		k = find(sx ~= 1 );
		if (isempty(k) )
			dim = 1;
		else
			dim = k(1);
		end
	else
		if( (any( size(dim) ~= 1)) || ( dim < 1) || ( dim ~= fix(dim)) )
			error('Dimension must be a scalar positive integer.');
		end
	end

	n = size(x, dim);
	x = sort(x, dim);
	% create a vector P = [1/N, 2/N, 1] along dimension dim
	p = (1:n) / n;
	siz = ones(1,dx);
	siz(dim) = n;
	p = reshape(p, siz);

	% replicate P along all dimensions except DIM to math the size of X
	rep = sx;
	rep(dim) = 1;
	p = repmat(p,rep);